#include <QApplication>
#include <QDesktopWidget>

#include "TreeWidget.h"

int main(int argc, char *argv[])
{
    QApplication app(argc, argv);

    TreeWidget* tree = new TreeWidget;

    QStringList asz;
    asz << "Top";
    QTreeWidgetItem* pParent = nullptr;
    QTreeWidgetItem* top = new QTreeWidgetItem(pParent, asz);
    tree->addTopLevelItem(top);

    asz.clear();
    asz << "Folder 1";
    pParent = top;
    QTreeWidgetItem* folder1 = new QTreeWidgetItem(pParent, asz);
    top->addChild(folder1);

    asz.clear();
    asz << "Item A";
    pParent = folder1;
    QTreeWidgetItem* itemA = new QTreeWidgetItem(pParent, asz);
    folder1->addChild(itemA);

    asz.clear();
    asz << "Item B";
    pParent = folder1;
    QTreeWidgetItem* itemB = new QTreeWidgetItem(pParent, asz);
    folder1->addChild(itemB);

    asz.clear();
    asz << "Item C";
    pParent = folder1;
    QTreeWidgetItem* itemC = new QTreeWidgetItem(pParent, asz);
    folder1->addChild(itemC);

    asz.clear();
    asz << "Item D";
    pParent = folder1;
    QTreeWidgetItem* itemD = new QTreeWidgetItem(pParent, asz);
    folder1->addChild(itemD);

    asz.clear();
    asz << "Folder 2";
    pParent = top;
    QTreeWidgetItem* folder2 = new QTreeWidgetItem(pParent, asz);
    top->addChild(folder2);

    asz.clear();
    asz << "Item E";
    pParent = folder2;
    QTreeWidgetItem* itemE = new QTreeWidgetItem(pParent, asz);
    folder2->addChild(itemE);

    asz.clear();
    asz << "Item F";
    pParent = folder2;
    QTreeWidgetItem* itemF = new QTreeWidgetItem(pParent, asz);
    folder2->addChild(itemF);

    asz.clear();
    asz << "Item G";
    pParent = folder2;
    QTreeWidgetItem* itemG = new QTreeWidgetItem(pParent, asz);
    folder2->addChild(itemG);

    asz.clear();
    asz << "Item H";
    pParent = folder2;
    QTreeWidgetItem* itemH = new QTreeWidgetItem(pParent, asz);
    folder2->addChild(itemH);

    tree->expandAll();

    const QSize availableSize = QApplication::desktop()->availableGeometry(tree).size();
    tree->resize(availableSize / 2);
    tree->setColumnWidth(0, tree->width() / 3);

    tree->setWindowTitle(QObject::tr("Test Drag and Drop Tree"));
    tree->show();

    return app.exec();
}
